Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision e68c8340d47c44d590ec9f47a0e81614a5ae66a3)
+++ boot/Makefile.common	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -111,6 +111,4 @@
 	$(USPACE_PATH)/srv/fs/ext4fs/ext4fs \
 	$(USPACE_PATH)/srv/taskmon/taskmon \
-	$(USPACE_PATH)/srv/hw/netif/ne2000/ne2000 \
-	$(USPACE_PATH)/srv/net/netif/lo/lo \
 	$(USPACE_PATH)/srv/net/nil/eth/eth \
 	$(USPACE_PATH)/srv/net/nil/nildummy/nildummy \
@@ -128,5 +126,7 @@
 	test/test1 \
 	test/test2 \
-	test/test3
+	test/test3 \
+	nic/lo \
+	nic/ne2k
 
 RD_DRV_CFG =
@@ -206,6 +206,6 @@
 NET_CFG = \
 	$(USPACE_PATH)/srv/net/cfg/general \
-	$(USPACE_PATH)/srv/net/cfg/lo \
-	$(USPACE_PATH)/srv/net/cfg/ne2k
+	$(USPACE_PATH)/srv/net/cfg/lo.nic \
+	$(USPACE_PATH)/srv/net/cfg/ne2k.nic
 endif
 
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision e68c8340d47c44d590ec9f47a0e81614a5ae66a3)
+++ uspace/Makefile	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -95,6 +95,4 @@
 	srv/hw/char/i8042 \
 	srv/hw/char/s3c24xx_uart \
-	srv/hw/netif/ne2000 \
-	srv/net/netif/lo \
 	srv/net/il/arp \
 	srv/net/il/ip \
@@ -102,4 +100,6 @@
 	srv/net/tl/udp \
 	srv/net/tl/tcp \
+	srv/net/nil/eth \
+	srv/net/nil/nildummy \
 	srv/net/net \
 	drv/infrastructure/root \
@@ -118,5 +118,7 @@
 	drv/bus/usb/usbmid \
 	drv/bus/usb/usbmouse \
-	drv/bus/usb/vhc
+	drv/bus/usb/vhc \
+	drv/nic/lo \
+	drv/nic/ne2k
 
 ifeq ($(CONFIG_PCC),y)
@@ -132,11 +134,4 @@
 	app/binutils
 endif
-
-## Networking
-#
-
-DIRS += \
-	srv/net/nil/eth \
-	srv/net/nil/nildummy
 
 ## Platform-specific hardware support
@@ -187,7 +182,7 @@
 	lib/softfloat \
 	lib/drv \
-	lib/packet \
 	lib/fb \
 	lib/net \
+	lib/nic \
 	lib/ext2 \
 	lib/ext4 \
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision e68c8340d47c44d590ec9f47a0e81614a5ae66a3)
+++ uspace/Makefile.common	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -124,6 +124,6 @@
 
 LIBDRV_PREFIX = $(LIB_PREFIX)/drv
-LIBPACKET_PREFIX = $(LIB_PREFIX)/packet
 LIBNET_PREFIX = $(LIB_PREFIX)/net
+LIBNIC_PREFIX = $(LIB_PREFIX)/nic
 LIBMINIX_PREFIX = $(LIB_PREFIX)/minix
 
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision e68c8340d47c44d590ec9f47a0e81614a5ae66a3)
+++ uspace/app/init/init.c	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -306,4 +306,6 @@
 	srv_start("/srv/s3c24ts");
 	
+	spawn("/srv/net");
+	
 	spawn("/srv/fb");
 	spawn("/srv/input");
Index: uspace/doc/doxygroups.h
===================================================================
--- uspace/doc/doxygroups.h	(revision e68c8340d47c44d590ec9f47a0e81614a5ae66a3)
+++ uspace/doc/doxygroups.h	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -33,16 +33,16 @@
 
 		/**
-		 * @defgroup netif Network interface drivers
-		 * @ingroup net
-		 */
-
-			/**
-			 * @defgroup lo Loopback Service
-			 * @ingroup netif
-			 */
-
-			/**
-			 * @defgroup ne2000 NE2000 network interface service
-			 * @ingroup netif
+		 * @defgroup nic Network interface controllers
+		 * @ingroup net
+		 */
+
+			/**
+			 * @defgroup libnic Base NIC framework library
+			 * @ingroup nic
+			 */
+
+			/**
+			 * @defgroup nic_drivers Drivers using the NICF
+			 * @ingroup nic
 			 */
 
Index: uspace/drv/infrastructure/rootvirt/devices.def
===================================================================
--- uspace/drv/infrastructure/rootvirt/devices.def	(revision e68c8340d47c44d590ec9f47a0e81614a5ae66a3)
+++ uspace/drv/infrastructure/rootvirt/devices.def	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -4,5 +4,13 @@
  * Unless the list is empty, the last item shall be followed by a comma.
  */
+
+/* Loopback network interface */
+{
+    .name = "lo",
+    .match_id = "virtual&loopback"
+},
+
 #ifdef CONFIG_TEST_DRIVERS
+
 {
 	.name = "test1",
@@ -25,6 +33,9 @@
 	.match_id = "virtual&test3"
 },
+
 #endif
+
 #ifdef CONFIG_RUN_VIRTUAL_USB_HC
+
 /* Virtual USB host controller. */
 {
@@ -32,3 +43,4 @@
 	.match_id = "usb&hc=vhc"
 },
+
 #endif
Index: uspace/drv/nic/lo/Makefile
===================================================================
--- uspace/drv/nic/lo/Makefile	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
+++ uspace/drv/nic/lo/Makefile	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2011 Radim Vansa
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a $(LIBNIC_PREFIX)/libnic.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include
+BINARY = lo
+
+SOURCES = \
+	lo.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/drv/nic/lo/lo.c
===================================================================
--- uspace/drv/nic/lo/lo.c	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
+++ uspace/drv/nic/lo/lo.c	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -0,0 +1,139 @@
+/*
+ * Copyright (c) 2011 Radim Vansa
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @addtogroup drv_lo
+ * @brief Loopback virtual device driver
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <stdio.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <async.h>
+#include <nic.h>
+#include <packet_client.h>
+
+#define NAME  "lo"
+
+static nic_address_t lo_addr = {
+	.address = {0, 0, 0, 0, 0, 0}
+};
+
+static ddf_dev_ops_t lo_dev_ops;
+
+static nic_device_info_t lo_info = {
+	.vendor_name = "HelenOS",
+	.model_name = "loopback",
+	.part_number = "N/A (virtual device)",
+	.serial_number = "N/A (virtual device)"
+};
+
+static void lo_write_packet(nic_t *nic_data, packet_t *packet)
+{
+	nic_report_send_ok(nic_data, 1, packet_get_data_length(packet));
+	nic_received_noneth_packet(nic_data, packet);
+}
+
+static int lo_set_address(ddf_fun_t *fun, const nic_address_t *address)
+{
+	printf("%s: Set loopback HW to " PRIMAC "\n", NAME,
+	    ARGSMAC(address->address));
+	return ENOTSUP;
+}
+
+static int lo_get_device_info(ddf_fun_t *fun, nic_device_info_t *info)
+{
+	assert(info);
+	memcpy(info, &lo_info, sizeof(nic_device_info_t));
+	return EOK;
+}
+
+static int lo_add_device(ddf_dev_t *dev)
+{
+	nic_t *nic_data = nic_create_and_bind(dev);
+	if (nic_data == NULL) {
+		printf("%s: Failed to initialize\n", NAME);
+		return ENOMEM;
+	}
+	
+	dev->driver_data = nic_data;
+	nic_set_write_packet_handler(nic_data, lo_write_packet);
+	
+	int rc = nic_connect_to_services(nic_data);
+	if (rc != EOK) {
+		printf("%s: Failed to connect to services\n", NAME);
+		nic_unbind_and_destroy(dev);
+		return rc;
+	}
+	
+	rc = nic_register_as_ddf_fun(nic_data, &lo_dev_ops);
+	if (rc != EOK) {
+		printf("%s: Failed to register as DDF function\n", NAME);
+		nic_unbind_and_destroy(dev);
+		return rc;
+	}
+	
+	rc = nic_report_address(nic_data, &lo_addr);
+	if (rc != EOK) {
+		printf("%s: Failed to setup loopback address\n", NAME);
+		nic_unbind_and_destroy(dev);
+		return rc;
+	}
+	
+	printf("%s: Adding loopback device '%s'\n", NAME, dev->name);
+	return EOK;
+}
+
+static nic_iface_t lo_nic_iface;
+
+static driver_ops_t lo_driver_ops = {
+	.add_device = lo_add_device,
+};
+
+static driver_t lo_driver = {
+	.name = NAME,
+	.driver_ops = &lo_driver_ops
+};
+
+int main(int argc, char *argv[])
+{
+	nic_driver_init(NAME);
+	nic_driver_implement(&lo_driver_ops, &lo_dev_ops, &lo_nic_iface);
+	lo_nic_iface.set_address = lo_set_address;
+	lo_nic_iface.get_device_info = lo_get_device_info;
+	
+	return ddf_driver_main(&lo_driver);
+}
+
+/** @}
+ */
Index: uspace/drv/nic/lo/lo.ma
===================================================================
--- uspace/drv/nic/lo/lo.ma	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
+++ uspace/drv/nic/lo/lo.ma	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -0,0 +1,1 @@
+10 virtual&loopback
Index: uspace/drv/nic/ne2k/Makefile
===================================================================
--- uspace/drv/nic/ne2k/Makefile	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
+++ uspace/drv/nic/ne2k/Makefile	(revision 7a68fe54c12652c8610c2dd4dc3a6726a771a930)
@@ -0,0 +1,38 @@
+#
+# Copyright (c) 2011 Radim Vansa
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a $(LIBNIC_PREFIX)/libnic.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include
+BINARY = ne2k
+
+SOURCES = \
+	dp8390.c \
+	ne2k.c
+
+include $(USPACE_PREFIX)/Makefile.common
